stages:
    - test
    - deploy


tests:
    # run test suite in various environments
    parallel:
        matrix:
            - TAURUS_TAG: ["bullseye"]
              QT_API: ["pyqt5", "pyside2"]
            - TAURUS_TAG: ["conda-3.6", "conda-3.7", "conda-3.8", "conda-3.9"]
              QT_API: ["pyqt5"]
    stage: test
    variables:
        PYTEST_QT_API: $QT_API
    image:
        name: registry.gitlab.com/taurus-org/taurus-docker:$TAURUS_TAG
    before_script:
        - pip install -e .
    script:
        - python3 -m pytest .


flake8:
    image:
        name: python:3.9-alpine
    before_script:
        - pip install flake8
    script:
        - flake8 .


deploy_to_pypi:
    stage:
        deploy
    image:
        name: python:3.9-slim-bullseye
    before_script:
        - pip install twine
    variables:
        TWINE_USERNAME: $PYPI_USERNAME
        TWINE_PASSWORD: $PYPI_PASSWORD
    script:
        - python setup.py sdist bdist_wheel
        - twine upload dist/*
    only:
        variables:
            - $CI_COMMIT_TAG =~ /^[0-9]+\.[0-9]+\.[0-9]+.*$/

